--- tarsnap-1.0.29/pkg/debian/control	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/pkg/debian/control	2011-05-24 02:41:34.000000000 -0700
@@ -2,12 +2,12 @@
 Section: net
 Priority: extra
 Maintainer: Mads Sulau Joergensen <mads@sulau.dk>
-Build-Depends: debhelper (>= 5), e2fslibs-dev, zlib1g-dev, libssl-dev, libbz2-dev
+Build-Depends: debhelper (>= 5), e2fslibs-dev, zlib1g-dev, libssl-dev, libbz2-dev, libattr1-dev, libacl1-dev
 Standards-Version: 3.7.2
 
 Package: tarsnap
 Architecture: any
-Depends: ${shlibs:Depends}, zlib1g
+Depends: ${shlibs:Depends}
 Description: tarsnap is an online encrypted snapshotted backup service
  Tarsnap is an encrypted snapshotted online backup service for BSD, 
  Linux, OpenSolaris, and OS X.
--- tarsnap-1.0.29/pkg/debian/rules	2011-01-19 20:32:50.000000000 -0800
+++ tarsnap-1.0.30/pkg/debian/rules	2011-05-24 02:42:08.000000000 -0700
@@ -17,7 +17,7 @@
 config.status: configure
 	dh_testdir
 	
-	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --sysconfdir=/etc --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"
+	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --sysconfdir=/etc --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-xattr --enable-acl --with-bz2lib CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"
 
 build: build-stamp
 
--- tarsnap-1.0.29/recrypt/recrypt.c	2011-02-02 05:31:44.000000000 -0800
+++ tarsnap-1.0.30/recrypt/recrypt.c	2011-05-08 14:23:18.000000000 -0700
@@ -223,36 +223,23 @@
 	int rc;
 
 	/* Make sure that nblist is a subset of oblist. */
-	i = j = 0;
-	do {
-		/* If we've hit the end of nblist, we're fine. */
-		if (j == nblistlen)
-			break;
-
-		/* If we've hit the end of oblist, it's missing something. */
-		if (i == oblistlen)
-			goto notsubset;
-
-		/* Compare the two block names we're looking at. */
-		rc = cmpblock(&oblist[i], &nblist[j]);
-
-		/* If the block from oblist is >, we're missing something. */
-		if (rc > 0)
-			goto notsubset;
+	for (i = j = 0; j < nblistlen; i++) {
+		/*
+		 * If we've hit the end of oblist or the next block in oblist
+		 * is greater than the next block in nblist, there's at least
+		 * one block in nblist which is not in oblist.
+		 */
+		if ((i == oblistlen) ||
+		    ((rc = cmpblock(&oblist[i], &nblist[j])) > 0)) {
+			warn0("New machine has data not in old machine!"
+			    "  Cannot continue.");
+			exit(1);
+		}
 
-		/* Advance the new block list pointer if blocks are ==. */
+		/* If we've matched this new block, advance the pointer. */
 		if (rc == 0)
 			j++;
-
-		/* Move on to the nest block. */
-		i++;
-		continue;
-
-notsubset:
-		/* The new block list has something not in the old list. */
-		warn0("New machine has data not in old machine!  Cannot continue.");
-		exit(1);
-	} while (1);
+	}
 
 	/* If the lists are identical, we have nothing to do. */
 	if (oblistlen == nblistlen) {
--- tarsnap-1.0.29/tar/bsdtar.c	2011-01-22 22:51:12.000000000 -0800
+++ tarsnap-1.0.30/tar/bsdtar.c	2011-08-02 01:54:08.000000000 -0700
@@ -267,6 +267,10 @@
 			/* libarchive doesn't need this; just ignore it. */
 			break;
 		case 'C': /* GNU tar */
+			if (strlen(bsdtar->optarg) == 0)
+				bsdtar_errc(bsdtar, 1, 0,
+				    "Meaningless option: -C ''");
+
 			set_chdir(bsdtar, bsdtar->optarg);
 			break;
 		case 'c': /* SUSv2 */
@@ -550,7 +554,13 @@
 			bsdtar->extract_flags |= ARCHIVE_EXTRACT_OWNER;
 			break;
 		case OPTION_STRIP_COMPONENTS: /* GNU tar 1.15 */
-			bsdtar->strip_components = atoi(bsdtar->optarg);
+			errno = 0;
+			bsdtar->strip_components = strtol(bsdtar->optarg,
+			    NULL, 0);
+			if (errno)
+				bsdtar_errc(bsdtar, 1, 0,
+				    "Invalid --strip-components argument: %s",
+				    bsdtar->optarg);
 			break;
 		case 'T': /* GNU tar */
 			bsdtar->names_from_file = bsdtar->optarg;
@@ -684,6 +694,10 @@
 	    (strlen(bsdtar->tapenames[0]) > 1023))
 		bsdtar_errc(bsdtar, 1, 0,
 		    "Cannot create an archive with a name > 1023 characters");
+	if ((bsdtar->mode == 'c') &&
+	    (strlen(bsdtar->tapenames[0]) == 0))
+		bsdtar_errc(bsdtar, 1, 0,
+		    "Cannot create an archive with an empty name");
 	if ((bsdtar->cachedir == NULL) &&
 	    (bsdtar->mode == 'c' || bsdtar->mode == 'd' ||
 	     bsdtar->mode == OPTION_RECOVER ||
@@ -760,6 +774,7 @@
 		if (realpath(bsdtar->cachedir, cachedir) == NULL)
 			bsdtar_errc(bsdtar, 1, errno, "realpath(%s)",
 			    bsdtar->cachedir);
+		free(bsdtar->cachedir);
 		bsdtar->cachedir = cachedir;
 	}
 
@@ -1522,7 +1537,7 @@
 needarg:
 	/* Option needs an argument. */
 	bsdtar_errc(bsdtar, 1, 0,
-	    "Argument requried for configuration file option: %s", conf_opt);
+	    "Argument required for configuration file option: %s", conf_opt);
 
 badopt:
 	/* No such option. */
--- tarsnap-1.0.29/tar/bsdtar.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/bsdtar.h	2011-05-07 00:34:51.000000000 -0700
@@ -48,7 +48,7 @@
 	const char	**tapenames; /* -f tapename */
 	size_t		  ntapes;
 	const char	 *homedir;
-	const char	 *cachedir; /* --cachedir */
+	char		 *cachedir; /* --cachedir */
 	dev_t		  cachedir_dev;
 	ino_t		  cachedir_ino;
 	int		  cachecrunch; /* --lowmem / --verylowmem */
--- tarsnap-1.0.29/tar/bsdtar_cygwin.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/bsdtar_cygwin.h	2011-05-30 06:07:29.000000000 -0700
@@ -32,7 +32,7 @@
 extern "C" {
 #endif
 
-/* a foward declaration, of sorts */
+/* a forward declaration, of sorts */
 typedef struct bsdtar * struct_bsdtar_p;
 
 extern int	bsdtar_is_privileged(struct bsdtar *bsdtar);
--- tarsnap-1.0.29/tar/bsdtar_platform.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/bsdtar_platform.h	2011-04-22 16:02:36.000000000 -0700
@@ -87,10 +87,10 @@
 #endif
 
 /*
- * Include "dirent.h" (or it's equivalent on several different platforms).
+ * Include "dirent.h" (or its equivalent on several different platforms).
  *
  * This is slightly modified from the GNU autoconf recipe.
- * In particular, FreeBSD includes d_namlen in it's dirent structure,
+ * In particular, FreeBSD includes d_namlen in its dirent structure,
  * so my configure script includes an explicit test for the d_namlen
  * field.
  */
--- tarsnap-1.0.29/tar/ccache/ccache.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/ccache/ccache.h	2011-04-21 12:53:27.000000000 -0700
@@ -21,7 +21,7 @@
  * ${sb}, to the multitape with write cookie ${cookie}.  Look up the file in
  * the chunkification cache ${cache}, and set ${fullentry} to a non-zero
  * value iff the cache can provide at least sb->st_size bytes of the archive
- * entry.  Return a cookie which can be passed to either ccahe_entry_write
+ * entry.  Return a cookie which can be passed to either ccache_entry_write
  * or ccache_entry_start depending upon whether ${fullentry} is zero or not.
  */
 CCACHE_ENTRY * ccache_entry_lookup(CCACHE *, const char *,
--- tarsnap-1.0.29/tar/ccache/ccache_entry.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/ccache/ccache_entry.c	2011-08-07 08:21:06.000000000 -0700
@@ -53,7 +53,7 @@
 	if (cce->hittrailer)
 		goto done;
 
-	/* Do we need to expand the allocate space? */
+	/* Do we need to expand the allocated space? */
 	if (ccr->nch >= ccr->nchalloc) {
 		/* Double the allocated memory. */
 		if (ccr->nchalloc)
--- tarsnap-1.0.29/tar/ccache/ccache_internal.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/ccache/ccache_internal.h	2011-08-08 13:05:57.000000000 -0700
@@ -59,7 +59,7 @@
 	/* Immediately following each record is suffix[]. */
 };
 /**
- * After all of the cache_record_external and suffix[] pairs, the
+ * After all of the ccache_record_external and suffix[] pairs, the
  * struct chunkheader chp[] and uint8_t ztrailer[] data is stored in the
  * same order.
  */
--- tarsnap-1.0.29/tar/chunks/chunks_directory.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/chunks/chunks_directory.c	2011-04-20 00:36:46.000000000 -0700
@@ -176,7 +176,7 @@
 	    (size_t)(sb.st_size - sizeof(struct chunkstats_external)) /
 	    sizeof(struct chunkdata_external);
 
-	/* Make sure we we don't get an integer overflow. */
+	/* Make sure we don't get an integer overflow. */
 	if (numchunks >= SIZE_MAX / sizeof(struct chunkdata)) {
 		warn0("on-disk directory is too large: %s", s);
 		goto err2;
--- tarsnap-1.0.29/tar/chunks/chunks_internal.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/chunks/chunks_internal.h	2011-08-08 13:42:11.000000000 -0700
@@ -20,7 +20,7 @@
 	size_t zlen;		/* Compressed length of chunk. */
 	size_t nrefs;		/* Number of existing tapes using this. */
 	size_t ncopies;		/* Number of copies of this chunk. */
-	size_t ncopies_ctape;	/* Used by chunks_fsck only. */
+	size_t ncopies_ctape;	/* Used by chunks_stats only. */
 	int flags;		/* See CHDATA_* flags. */
 };
 
--- tarsnap-1.0.29/tar/chunks/chunks_stats_internal.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/chunks/chunks_stats_internal.c	2011-05-24 23:14:53.000000000 -0700
@@ -96,7 +96,7 @@
 	s.s_len = stats->s_len + stats_extra->s_len;
 	s.s_zlen = stats->s_zlen + stats_extra->s_zlen;
 
-	/* Stringify values, */
+	/* Stringify values. */
 	if (tarsnap_opt_humanize_numbers) {
 		if ((s_lenstr = humansize(s.s_len)) == NULL)
 			goto err0;
--- tarsnap-1.0.29/tar/cmdline.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/cmdline.c	2011-05-30 05:54:18.000000000 -0700
@@ -197,7 +197,7 @@
  *
  * TODO: If we want to support arbitrary command-line options from -T
  * input (as GNU tar does), we may need to extend this to handle option
- * words from sources other than argv/arc.  I'm not really sure if I
+ * words from sources other than argv/argc.  I'm not really sure if I
  * like that feature of GNU tar, so it's certainly not a priority.
  */
 
--- tarsnap-1.0.29/tar/glue/archive_multitape.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/glue/archive_multitape.c	2011-04-20 00:36:56.000000000 -0700
@@ -118,7 +118,7 @@
  * Open the multitape tape ${tapename} for writing and associate it with the
  * archive $a$.  If ${printstats} is non-zero, print archive statistics when
  * the tape is closed.  If ${dryrun} is non-zero, perform a dry run.  Return
- * a cookie which which can be passed to the multitape layer.
+ * a cookie which can be passed to the multitape layer.
  */
 void *
 archive_write_open_multitape(struct archive * a, uint64_t machinenum,
--- tarsnap-1.0.29/tar/glue/archive_multitape.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/glue/archive_multitape.h	2011-04-20 00:37:12.000000000 -0700
@@ -14,7 +14,7 @@
  * Open the multitape tape ${tapename} for writing and associate it with the
  * archive $a$.  If ${printstats} is non-zero, print archive statistics when
  * the tape is closed.  If ${dryrun} is non-zero, perform a dry run.  Return
- * a cookie which which can be passed to the multitape layer.
+ * a cookie which can be passed to the multitape layer.
  */
 void * archive_write_open_multitape(struct archive *, uint64_t, const char *,
     const char *, int argc, char ** argv, int, int);
--- tarsnap-1.0.29/tar/matching.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/matching.c	2011-05-26 15:57:08.000000000 -0700
@@ -122,20 +122,21 @@
 add_pattern(struct bsdtar *bsdtar, struct match **list, const char *pattern)
 {
 	struct match *match;
+	size_t len;
 
-	match = malloc(sizeof(*match) + strlen(pattern) + 1);
+	len = strlen(pattern);
+	match = malloc(sizeof(*match) + len + 1);
 	if (match == NULL)
 		bsdtar_errc(bsdtar, 1, errno, "Out of memory");
 	strcpy(match->pattern, pattern);
 	/* Both "foo/" and "foo" should match "foo/bar". */
-	if (match->pattern[strlen(match->pattern)-1] == '/')
-		match->pattern[strlen(match->pattern)-1] = '\0';
+	if (len && match->pattern[len - 1] == '/')
+		match->pattern[len - 1] = '\0';
 	match->next = *list;
 	*list = match;
 	match->matches = 0;
 }
 
-
 int
 excluded(struct bsdtar *bsdtar, const char *pathname)
 {
--- tarsnap-1.0.29/tar/multitape/chunkify.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/multitape/chunkify.c	2011-06-22 04:19:06.000000000 -0700
@@ -19,7 +19,7 @@
 	uint32_t p;		/* Modulus */
 	uint32_t pp;		/* - p^(-1) mod 2^32 */
 	uint32_t ar;		/* alpha * 2^32 mod p */
-	uint32_t * cm;		/* Coefficent map modulo p */
+	uint32_t * cm;		/* Coefficient map modulo p */
 	uint32_t htlen;		/* Size of hash table in 2-word entries */
 	uint32_t blen;		/* Length of buf[] */
 	uint32_t w;		/* Minimum substring length; size of b[] */
@@ -48,7 +48,7 @@
 static uint32_t isqrt(uint32_t x);
 static void chunkify_start(CHUNKIFIER * c);
 
-/* Returns nonzero iff n is prime */
+/* Returns nonzero iff n is prime. */
 static int
 isprime(uint32_t n)
 {
@@ -136,15 +136,15 @@
 {
 	uint32_t i;
 
-	/* No entries in the hash table */
+	/* No entries in the hash table. */
 	for (i = 0; i < c->htlen; i++)
 		c->ht[i * 2] = - c->htlen;
 
-	/* Nothing in the queue waiting to be added to the table, either */
+	/* Nothing in the queue waiting to be added to the table, either. */
 	for (i = 0; i < c->w; i++)
 		c->b[i] = c->p;
 
-	/* No bytes input yet */
+	/* No bytes input yet. */
 	c->akr = (- c->p) % c->p;
 	c->yka = 0;
 	c->k = 0;
@@ -255,7 +255,7 @@
 	c->p = nextprime(pmin + (c->p % isqrt(c->mu)));
 	/* c->p <= 1431655739 < 1431655765 = floor(2^32 / 3) */
 
-	/* Compute pp = - p^(-1) mod 2^32 */
+	/* Compute pp = - p^(-1) mod 2^32. */
 	c->pp = ((2 * c->p + 4) & 8) - c->p;	/* pp = - 1/p mod 2^4 */
 	c->pp *= 2 + c->p * c->pp;		/* pp = - 1/p mod 2^8 */
 	c->pp *= 2 + c->p * c->pp;		/* pp = - 1/p mod 2^16 */
@@ -273,7 +273,7 @@
 	}
 
 	/*
-	 * Prepare for incoming data
+	 * Prepare for incoming data.
 	 */
 	chunkify_start(c);
 
@@ -283,7 +283,7 @@
 	return (c);
 
 err:
-	/* free(NULL) is safe, so it doesn't matter where we jumped from */
+	/* free(NULL) is safe, so it doesn't matter where we jumped from. */
 	free(c->buf);
 	free(c->ht);
 	free(c->b);
@@ -301,7 +301,7 @@
 	int rc;
 
 	for (i = 0; i < buflen; i++) {
-		/* Add byte to buffer */
+		/* Add byte to buffer. */
 		c->buf[c->k] = buf[i];
 
 		/* k := k + 1 */
@@ -327,14 +327,14 @@
 			continue;
 
 		/*
-		 * Update state to add new character
+		 * Update state to add new character.
 		 */
 
 		/* y_k(a) := y_k(a) + a^k * x_k mod p */
-		/* yka <= p * (2 + p / (2^32 - p)) <= p * 2.5 < 2^31 + p*/
+		/* yka <= p * (2 + p / (2^32 - p)) <= p * 2.5 < 2^31 + p */
 		c->yka += mmul(c->akr, c->cm[buf[i]], c->p, c->pp);
 
-		/* Each step reduces yka by p iff yka >= p */
+		/* Each step reduces yka by p iff yka >= p. */
 		c->yka -= c->p & (((c->yka - c->p) >> 31) - 1);
 		c->yka -= c->p & (((c->yka - c->p) >> 31) - 1);
 
@@ -358,7 +358,7 @@
 			if (c->k - c->ht[2 * htpos] - 1 >= 2 * c->r)
 				break;
 
-			/* Move to the next position in the table */
+			/* Move to the next position in the table. */
 			htpos = (htpos + 1) & (c->htlen - 1);
 		} while (1);
 
@@ -375,7 +375,7 @@
 				break;
 			}
 
-			/* Move to the next position in the table */
+			/* Move to the next position in the table. */
 			htpos = (htpos + 1) & (c->htlen - 1);
 		} while (1);
 
@@ -406,16 +406,16 @@
 {
 	int rc;
 
-	/* If we haven't started the chunk yet, don't end it either */
+	/* If we haven't started the chunk yet, don't end it either. */
 	if (c->k == 0)
 		return (0);
 
-	/* Process the chunk */
+	/* Process the chunk. */
 	rc = (c->chunkdone)(c->cookie, c->buf, c->k);
 	if (rc)
 		return (rc);
 
-	/* Prepare for more input */
+	/* Prepare for more input. */
 	chunkify_start(c);
 
 	return (0);
@@ -429,7 +429,7 @@
 	if (c == NULL)
 		return;
 
-	/* Free everything */
+	/* Free everything. */
 	free(c->buf);
 	free(c->ht);
 	free(c->b);
--- tarsnap-1.0.29/tar/multitape/multitape_fsck.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/multitape/multitape_fsck.c	2011-04-21 12:53:51.000000000 -0700
@@ -164,7 +164,7 @@
 	if (storage_directory_read(machinenum, 'm', 0, &flist, &nfiles))
 		goto err0;
 
-	/* Allocate space for nfiles tapemetadat structures. */
+	/* Allocate space for nfiles tapemetadata structures. */
 	if ((mdats = malloc(nfiles * sizeof(struct tapemetadata *))) == NULL)
 		goto err1;
 	nvalids = 0;
--- tarsnap-1.0.29/tar/multitape/multitape_metaindex.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/multitape/multitape_metaindex.c	2011-08-14 13:59:01.000000000 -0700
@@ -87,17 +87,20 @@
 	/* Copy values into buffer. */
 	le32enc(p, mind->hindexlen);
 	p += 4;
-	memcpy(p, mind->hindex, mind->hindexlen);
+	if (mind->hindexlen > 0)
+		memcpy(p, mind->hindex, mind->hindexlen);
 	p += mind->hindexlen;
 
 	le32enc(p, mind->cindexlen);
 	p += 4;
-	memcpy(p, mind->cindex, mind->cindexlen);
+	if (mind->cindexlen > 0)
+		memcpy(p, mind->cindex, mind->cindexlen);
 	p += mind->cindexlen;
 
 	le32enc(p, mind->tindexlen);
 	p += 4;
-	memcpy(p, mind->tindex, mind->tindexlen);
+	if (mind->tindexlen > 0)
+		memcpy(p, mind->tindex, mind->tindexlen);
 	p += mind->tindexlen;
 
 	/* Compute hash of tape name. */
@@ -222,9 +225,11 @@
 
 	if (buflen < mind->hindexlen)
 		goto corrupt0;
-	if ((mind->hindex = malloc(mind->hindexlen)) == NULL)
+	if (((mind->hindex = malloc(mind->hindexlen)) == NULL) &&
+	    (mind->hindexlen > 0))
 		goto err1;
-	memcpy(mind->hindex, buf, mind->hindexlen);
+	if (mind->hindexlen > 0)
+		memcpy(mind->hindex, buf, mind->hindexlen);
 	buf += mind->hindexlen;
 	buflen -= mind->hindexlen;
 
@@ -237,9 +242,11 @@
 
 	if (buflen < mind->cindexlen)
 		goto corrupt1;
-	if ((mind->cindex = malloc(mind->cindexlen)) == NULL)
+	if (((mind->cindex = malloc(mind->cindexlen)) == NULL) &&
+	    (mind->cindexlen > 0))
 		goto err2;
-	memcpy(mind->cindex, buf, mind->cindexlen);
+	if (mind->cindexlen > 0)
+		memcpy(mind->cindex, buf, mind->cindexlen);
 	buf += mind->cindexlen;
 	buflen -= mind->cindexlen;
 
@@ -252,9 +259,11 @@
 
 	if (buflen < mind->tindexlen)
 		goto corrupt2;
-	if ((mind->tindex = malloc(mind->tindexlen)) == NULL)
+	if (((mind->tindex = malloc(mind->tindexlen)) == NULL) &&
+	    (mind->tindexlen > 0))
 		goto err3;
-	memcpy(mind->tindex, buf, mind->tindexlen);
+	if (mind->tindexlen > 0)
+		memcpy(mind->tindex, buf, mind->tindexlen);
 	buf += mind->tindexlen;
 	buflen -= mind->tindexlen;
 
--- tarsnap-1.0.29/tar/multitape/multitape_write.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/multitape/multitape_write.c	2011-05-08 14:30:03.000000000 -0700
@@ -46,7 +46,7 @@
 	uint64_t machinenum;	/* Machine number. */
 	char * cachedir;	/* Cache directory. */
 	time_t ctime;		/* Archive creation time. */
-	int argc;		/* Number of commmand-line arguments. */
+	int argc;		/* Number of command-line arguments. */
 	char ** argv;		/* Command-line arguments. */
 	int stats_enabled;	/* Stats printed on close. */
 	int eof;		/* Tape is truncated at current position. */
--- tarsnap-1.0.29/tar/storage/storage.h	2011-01-23 21:23:46.000000000 -0800
+++ tarsnap-1.0.30/tar/storage/storage.h	2011-04-21 12:54:52.000000000 -0700
@@ -47,7 +47,7 @@
  * malloc a buffer.  Invoke ${callback}(${cookie}, status, b, blen) when
  * complete, where ${status} is 0, 1, 2, or -1 as per storage_read_file,
  * ${b} is the buffer into which the data was read (which will be ${buf} if
- * that value was non-NUL) and ${blen} is the length of the file.
+ * that value was non-NULL) and ${blen} is the length of the file.
  */
 int storage_read_file_callback(STORAGE_R *, uint8_t *, size_t, char,
     const uint8_t[32], int(*)(void *, int, uint8_t *, size_t), void *);
@@ -60,7 +60,7 @@
 
 /**
  * storage_write_start(machinenum, lastseq, seqnum, dryrun):
- * Start a write transaction, presuming that ${lastseq} is the the sequence
+ * Start a write transaction, presuming that ${lastseq} is the sequence
  * number of the last committed transaction, or zeroes if there is no
  * previous transaction; and store the sequence number of the new transaction
  * into ${seqnum}.  If ${dryrun} is nonzero, perform a dry run.
@@ -108,7 +108,7 @@
 
 /**
  * storage_delete_start(machinenum, lastseq, seqnum):
- * Start a delete transaction, presuming that ${lastseq} is the the sequence
+ * Start a delete transaction, presuming that ${lastseq} is the sequence
  * number of the last committed transaction, or zeroes if there is no
  * previous transaction; and store the sequence number of the new transaction
  * into ${seqnum}.
@@ -149,7 +149,7 @@
 
 /**
  * storage_delete_free(S):
- * Free any memory allocated as part of the delete transcation associated
+ * Free any memory allocated as part of the delete transaction associated
  * with the cookie ${S}; the transaction will not be committed.
  */
 void storage_delete_free(STORAGE_D *);
--- tarsnap-1.0.29/tar/storage/storage_delete.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/storage/storage_delete.c	2011-04-21 12:54:35.000000000 -0700
@@ -50,7 +50,7 @@
 
 /**
  * storage_delete_start(machinenum, lastseq, seqnum):
- * Start a delete transaction, presuming that ${lastseq} is the the sequence
+ * Start a delete transaction, presuming that ${lastseq} is the sequence
  * number of the last committed transaction, or zeroes if there is no
  * previous transaction; and store the sequence number of the new transaction
  * into ${seqnum}.
@@ -337,7 +337,7 @@
 
 /**
  * storage_delete_free(S):
- * Free any memory allocated as part of the delete transcation associated
+ * Free any memory allocated as part of the delete transaction associated
  * with the cookie ${S}; the transaction will not be committed.
  */
 void
--- tarsnap-1.0.29/tar/storage/storage_directory.c	2011-01-26 01:50:49.000000000 -0800
+++ tarsnap-1.0.30/tar/storage/storage_directory.c	2011-08-14 13:14:07.000000000 -0700
@@ -198,8 +198,8 @@
 		}
 		if ((flist_new = malloc(C->nfiles_alloc * 32)) == NULL)
 			goto err0;
-
-		memcpy(flist_new, C->flist, C->nfiles * 32);
+		if (C->nfiles > 0)
+			memcpy(flist_new, C->flist, C->nfiles * 32);
 		free(C->flist);
 		C->flist = flist_new;
 	}
--- tarsnap-1.0.29/tar/storage/storage_read.c	2011-01-23 22:54:19.000000000 -0800
+++ tarsnap-1.0.30/tar/storage/storage_read.c	2011-04-21 12:55:05.000000000 -0700
@@ -150,7 +150,7 @@
  * malloc a buffer.  Invoke ${callback}(${cookie}, status, b, blen) when
  * complete, where ${status} is 0, 1, 2, or -1 as per storage_read_file,
  * ${b} is the buffer into which the data was read (which will be ${buf} if
- * that value was non-NUL) and ${blen} is the length of the file.
+ * that value was non-NULL) and ${blen} is the length of the file.
  */
 int
 storage_read_file_callback(STORAGE_R * S, uint8_t * buf, size_t buflen,
--- tarsnap-1.0.29/tar/storage/storage_transaction.c	2011-02-01 12:56:25.000000000 -0800
+++ tarsnap-1.0.30/tar/storage/storage_transaction.c	2011-05-30 05:55:03.000000000 -0700
@@ -142,8 +142,8 @@
 	C.whichkey = whichkey;
 
 	/*
-	 * As the server to cancel any in-progress transaction; if it asks us
-	 * to go away and come back later, sleep 1 second and then poke it
+	 * Ask the server to cancel any in-progress transaction; if it asks
+	 * us to go away and come back later, sleep 1 second and then poke it
 	 * again.
 	 */
 	do {
--- tarsnap-1.0.29/tar/storage/storage_write.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/storage/storage_write.c	2011-04-21 12:54:04.000000000 -0700
@@ -118,7 +118,7 @@
 
 /**
  * storage_write_start(machinenum, lastseq, seqnum, dryrun):
- * Start a write transaction, presuming that ${lastseq} is the the sequence
+ * Start a write transaction, presuming that ${lastseq} is the sequence
  * number of the last committed transaction, or zeroes if there is no
  * previous transaction; and store the sequence number of the new transaction
  * into ${seqnum}.  If ${dryrun} is nonzero, perform a dry run.
@@ -463,7 +463,7 @@
 			goto err0;
 	}
 
-	/* Succes! */
+	/* Success! */
 	return (0);
 
 err0:
--- tarsnap-1.0.29/tar/subst.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/subst.c	2011-07-28 21:02:17.000000000 -0700
@@ -153,7 +153,8 @@
 	new_str = malloc(old_len + len + 1);
 	if (new_str == NULL)
 		bsdtar_errc(bsdtar, 1, errno, "Out of memory");
-	memcpy(new_str, *str, old_len);
+	if (*str != NULL)
+		memcpy(new_str, *str, old_len);
 	memcpy(new_str + old_len, append, len);
 	new_str[old_len + len] = '\0';
 	free(*str);
@@ -174,7 +175,8 @@
 	new_str = malloc(old_len + strlen(append) + 1);
 	if (new_str == NULL)
 		bsdtar_errc(bsdtar, 1, errno, "Out of memory");
-	memcpy(new_str, *str, old_len);
+	if (*str != NULL)
+		memcpy(new_str, *str, old_len);
 	strcpy(new_str + old_len, append);
 	free(*str);
 	*str = new_str;
--- tarsnap-1.0.29/tar/tarsnap.1-man.in	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/tarsnap.1-man.in	2011-04-22 16:13:38.000000000 -0700
@@ -595,7 +595,7 @@
 Extract files as sparse files.
 For every block on disk, check first if it contains only NULL bytes and seek
 over it otherwise.
-This works similiar to the conv=sparse option of dd.
+This works similar to the conv=sparse option of dd.
 .It Fl s Ar pattern
 Modify file or archive member names according to
 .Pa pattern .
@@ -603,10 +603,10 @@
 old is a basic regular expression.
 If it doesn't apply, the pattern is skipped.
 new is the replacement string of the matched part.
-~ is substituted with the match, \1 to \9 with the content of
+~ is substituted with the match, \e1 to \e9 with the contents of
 the corresponding captured group.
 The optional trailing g specifies that matching should continue
-after the matched part and stopped on the first unmatched pattern.
+after the matched part and stop on the first unmatched pattern.
 The optional trailing s specifies that the pattern applies to the value
 of symbolic links.
 The optional trailing p specifies that after a successful substitution
--- tarsnap-1.0.29/tar/tarsnap.1-mdoc.in	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/tarsnap.1-mdoc.in	2011-04-22 16:13:38.000000000 -0700
@@ -595,7 +595,7 @@
 Extract files as sparse files.
 For every block on disk, check first if it contains only NULL bytes and seek
 over it otherwise.
-This works similiar to the conv=sparse option of dd.
+This works similar to the conv=sparse option of dd.
 .It Fl s Ar pattern
 Modify file or archive member names according to
 .Pa pattern .
@@ -603,10 +603,10 @@
 old is a basic regular expression.
 If it doesn't apply, the pattern is skipped.
 new is the replacement string of the matched part.
-~ is substituted with the match, \1 to \9 with the content of
+~ is substituted with the match, \e1 to \e9 with the contents of
 the corresponding captured group.
 The optional trailing g specifies that matching should continue
-after the matched part and stopped on the first unmatched pattern.
+after the matched part and stop on the first unmatched pattern.
 The optional trailing s specifies that the pattern applies to the value
 of symbolic links.
 The optional trailing p specifies that after a successful substitution
--- tarsnap-1.0.29/tar/tree.c	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/tree.c	2011-08-11 17:38:00.000000000 -0700
@@ -183,6 +183,8 @@
 	struct tree_entry *te;
 
 	te = malloc(sizeof(*te));
+	if (te == NULL)
+		abort();
 	memset(te, 0, sizeof(*te));
 	te->next = t->stack;
 	t->stack = te;
@@ -203,6 +205,7 @@
 tree_append(struct tree *t, const char *name, size_t name_length)
 {
 	char *p;
+	size_t size_needed;
 
 	if (t->buff != NULL)
 		t->buff[t->dirname_length] = '\0';
@@ -211,12 +214,16 @@
 		name_length--;
 
 	/* Resize pathname buffer as needed. */
-	while (name_length + 1 + t->dirname_length >= t->buff_length) {
-		t->buff_length *= 2;
+	size_needed = name_length + 1 + t->dirname_length;
+	if (t->buff_length < size_needed) {
 		if (t->buff_length < 1024)
 			t->buff_length = 1024;
+		while (t->buff_length < size_needed)
+			t->buff_length *= 2;
 		t->buff = realloc(t->buff, t->buff_length);
 	}
+	if (t->buff == NULL)
+		abort();
 	p = t->buff + t->dirname_length;
 	t->path_length = t->dirname_length + name_length;
 	/* Add a separating '/' if it's needed. */
@@ -249,6 +256,8 @@
 	struct tree *t;
 
 	t = malloc(sizeof(*t));
+	if (t == NULL)
+		abort();
 	memset(t, 0, sizeof(*t));
 	tree_append(t, path, strlen(path));
 #ifdef HAVE_FCHDIR
@@ -348,9 +357,9 @@
 	 * violation.  Just crash now. */
 	if (t->visit_type == TREE_ERROR_FATAL) {
 		const char *msg = "Unable to continue traversing"
-		    " directory heirarchy after a fatal error.";
+		    " directory hierarchy after a fatal error.\n";
 		write(2, msg, strlen(msg));
-		*(int *)0 = 1; /* Deliberate SEGV; NULL pointer dereference. */
+		*(volatile int *)0 = 1; /* Deliberate SEGV; NULL pointer dereference. */
 		exit(1); /* In case the SEGV didn't work. */
 	}
 
@@ -363,8 +372,17 @@
 	while (t->stack != NULL) {
 		/* If there's an open dir, get the next entry from there. */
 		while (t->d != NULL) {
+			errno = 0;
 			de = readdir(t->d);
 			if (de == NULL) {
+				if (errno) {
+					/* If readdir fails, we're screwed. */
+					closedir(t->d);
+					t->d = NULL;
+					t->visit_type = TREE_ERROR_FATAL;
+					return (t->visit_type);
+				}
+				/* Reached end of directory. */
 				closedir(t->d);
 				t->d = NULL;
 			} else if (de->d_name[0] == '.'
@@ -641,9 +659,11 @@
 /*
  * Terminate the traversal and release any resources.
  */
-void
+int
 tree_close(struct tree *t)
 {
+	int rc = 0;
+
 	/* Release anything remaining in the stack. */
 	while (t->stack != NULL)
 		tree_pop(t);
@@ -652,16 +672,18 @@
 	/* chdir() back to where we started. */
 #ifdef HAVE_FCHDIR
 	if (t->initialDirFd >= 0) {
-		fchdir(t->initialDirFd);
+		rc = fchdir(t->initialDirFd);
 		close(t->initialDirFd);
 		t->initialDirFd = -1;
 	}
 #elif defined(_WIN32) && !defined(__CYGWIN__)
 	if (t->initialDir != NULL) {
-		chdir(t->initialDir);
+		rc = chdir(t->initialDir);
 		free(t->initialDir);
 		t->initialDir = NULL;
 	}
 #endif
 	free(t);
+
+	return (rc);
 }
--- tarsnap-1.0.29/tar/tree.h	2011-01-19 20:32:48.000000000 -0800
+++ tarsnap-1.0.30/tar/tree.h	2011-08-02 09:17:02.000000000 -0700
@@ -54,7 +54,7 @@
 
 /* Initiate/terminate a tree traversal. */
 struct tree *tree_open(const char * /* pathname */);
-void tree_close(struct tree *);
+int tree_close(struct tree *);
 
 /*
  * tree_next() returns Zero if there is no next entry, non-zero if
